<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\FuncionarioService;
use FM\Traits\TResponse;

class FuncionarioController extends FMCrud{
    
    use TResponse;
    
    protected $FuncionarioService;
   
    public function __construct($crudService, $environment, FuncionarioService $FuncionarioService) {
        parent::__construct($crudService, $environment);
        $this->FuncionarioService = $FuncionarioService;
    }

    public function getEmployee(DTO\Request $request, DTO\Response $response){
        $params = $request->getParameters();
        $var = $this->FuncionarioService->getEmployee($params);
        $dtsVal = new DataSet("employee",$var);
        $response->addDataSet($dtsVal);
    }

    public function joinPerfilAcesso(DTO\Request $request, DTO\Response $response) {
        $params = $request->getParameters();
        $funcs = $this->FuncionarioService->joinPerfilAcesso($params);
        
        $dtsVal = new DataSet("Funcionarios", $funcs);
        $response->addDataSet($dtsVal);
    }

    public function getFuncionario(DTO\Request $request, DTO\Response $response){
        try {
            $data = $this->FuncionarioService->getFuncionario($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}

?>