/*
NOME: 0030_DENSTPO_USR_EXPORTAREDZ_DENADAI_TXT.SQL

DESCRIO: Procedimento para gerao de arquivos em vendas (Reduo Z, Vendas) em formato .txt

CRIAO: 08/04/2015 - Fabrcio Marcelo da Silva

@C:\web_585\sql\end_conv\oracle\clientes\den\0030_DENSTPO_USR_EXPORTAREDZ_DENADAI_TXT.SQL

RAISE_APPLICATION_ERROR(-20501, '' , TRUE);
*/

CREATE OR REPLACE PROCEDURE EXPORTA_VENDAS_DN (
   VAGRUPAMENTO  IN VARCHAR2)
IS
   V_FILIAL       VARCHAR(10);
   V_OUTROSR      FLOAT;
   V_IMPDEBT      FLOAT;
   V_WD_BAS7      FLOAT;
   V_WD_BAS84     FLOAT;
   V_WD_BAS12     FLOAT;
   V_WD_BAS18     FLOAT;
   V_WD_BAS25     FLOAT;
   V_WD_BAS32     FLOAT;
   V_NOVOCODIGO   INTEGER;
   V_DADOS        VARCHAR2(700);
   V_LINHA        INT := 0;
   V_DATAARQ      VARCHAR2(8);
   V_COUNT        NUMBER;
BEGIN
   --Configurao do ambiente
   EXECUTE IMMEDIATE 'ALTER SESSION SET NLS_LANGUAGE=''BRAZILIAN PORTUGUESE''';
   EXECUTE IMMEDIATE 'ALTER SESSION SET NLS_DATE_FORMAT = ''DD/MM/YYYY''';

   V_DATAARQ := TO_CHAR(SYSDATE, 'YYYYMMDD');

   DELETE VND_TMP;
   COMMIT;

   V_COUNT := 0;

   -- Reduo Z - Tipo 1 - Filial_AAAAMMDD_RZ.TXT
   FOR C_REDZEXPORT IN
      (SELECT R.CDFILIAL  , DTREDUCAOZ  , NRECFREDZ   , NRSERIEREDZ,
              NRREDREDZ   , VRGTREDZ    , NRPRIMCFREDZ, NRULTCFREDZ,
              VRTOTCANREDZ, VRVENLIQREDZ, VRVENBRUREDZ, VRTOTDESREDZ, VRSTRIBREDZ,
              VRISENCREDZ , VRNINCIDREDZ, VRISSREDZ   ,
              (LPAD(TO_NUMBER(NRREINIREDZ), 3, '0')) as NRREINIREDZ,
              CDCAIXA
         FROM REDUCAOZ R, (SELECT DISTINCT(CDFILIAL)
                             FROM FILGRUPFILI
                            WHERE USR_IDPROTHEUS = 'S'
                            AND FILGRUPFILI.CDGRUPFILI = VAGRUPAMENTO) F
        WHERE R.CDFILIAL = F.CDFILIAL
          AND USR_DTEXPORTA IS NULL
          AND NVL(USR_IDEXPORTA, 'S') = 'S'
--          AND R.IDORIGEMREDZ = 'IMP'
        ORDER BY R.CDFILIAL, DTREDUCAOZ, NRECFREDZ
       )
   LOOP
      V_OUTROSR  := 0;
      V_IMPDEBT  := 0;
      V_WD_BAS7  := 0;
      V_WD_BAS84 := 0;
      V_WD_BAS12 := 0;
      V_WD_BAS18 := 0;
      V_WD_BAS25 := 0;
      V_WD_BAS32 := 0;

      SELECT MAX(CDGRUPFILI)
        INTO V_FILIAL
        FROM FILGRUPFILI
       WHERE CDFILIAL = C_REDZEXPORT.CDFILIAL
         AND USR_IDPROTHEUS = 'S'
         AND CDGRUPFILI = VAGRUPAMENTO;

      IF NOT V_FILIAL IS NULL THEN
         BEGIN
            SELECT SUM(VRACUTOTNFIS)
              INTO V_OUTROSR
              FROM TOTNFISCREDZ
             WHERE CDFILIAL   = C_REDZEXPORT.CDFILIAL
               AND DTREDUCAOZ = C_REDZEXPORT.DTREDUCAOZ
               AND NRECFREDZ  = C_REDZEXPORT.NRECFREDZ;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_OUTROSR := 0;
         END;

         BEGIN
            SELECT SUM(VRIMPOSTORZ)
              INTO V_IMPDEBT
              FROM IMPOSTOREDZ
             WHERE CDFILIAL   = C_REDZEXPORT.CDFILIAL
               AND DTREDUCAOZ = C_REDZEXPORT.DTREDUCAOZ
               AND NRECFREDZ  = C_REDZEXPORT.NRECFREDZ;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_IMPDEBT := 0;
         END;

         BEGIN
            SELECT VRBCALCIMPRZ
              INTO V_WD_BAS32
              FROM IMPOSTOREDZ
             WHERE CDFILIAL = C_REDZEXPORT.CDFILIAL
               AND CDCAIXA =  C_REDZEXPORT.CDCAIXA
               AND NRECFREDZ = C_REDZEXPORT.NRECFREDZ
               AND DTREDUCAOZ = C_REDZEXPORT.DTREDUCAOZ
               AND CDIMPOSTO =  '00'
               AND VRALIQIMPRZ = 3.2;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_WD_BAS32 := 0;
         END;

         BEGIN
            SELECT VRBCALCIMPRZ
              INTO V_WD_BAS84
              FROM IMPOSTOREDZ
             WHERE CDFILIAL = C_REDZEXPORT.CDFILIAL
               AND CDCAIXA =  C_REDZEXPORT.CDCAIXA
               AND NRECFREDZ = C_REDZEXPORT.NRECFREDZ
               AND DTREDUCAOZ = C_REDZEXPORT.DTREDUCAOZ
               AND CDIMPOSTO =  '00'
               AND VRALIQIMPRZ = 8.4;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_WD_BAS84 := 0;
         END;

         BEGIN
            SELECT VRBCALCIMPRZ
              INTO V_WD_BAS7
              FROM IMPOSTOREDZ
             WHERE CDFILIAL = C_REDZEXPORT.CDFILIAL
               AND CDCAIXA =  C_REDZEXPORT.CDCAIXA
               AND NRECFREDZ = C_REDZEXPORT.NRECFREDZ
               AND DTREDUCAOZ = C_REDZEXPORT.DTREDUCAOZ
               AND CDIMPOSTO =  '00'
               AND VRALIQIMPRZ = 7;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_WD_BAS7 := 0;
         END;

         BEGIN
            SELECT VRBCALCIMPRZ
              INTO V_WD_BAS12
              FROM IMPOSTOREDZ
             WHERE CDFILIAL = C_REDZEXPORT.CDFILIAL
               AND CDCAIXA =  C_REDZEXPORT.CDCAIXA
               AND NRECFREDZ = C_REDZEXPORT.NRECFREDZ
               AND DTREDUCAOZ = C_REDZEXPORT.DTREDUCAOZ
               AND CDIMPOSTO =  '00'
               AND VRALIQIMPRZ = 12;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_WD_BAS12 := 0;
         END;

         BEGIN
            SELECT VRBCALCIMPRZ
              INTO V_WD_BAS18
              FROM IMPOSTOREDZ
             WHERE CDFILIAL = C_REDZEXPORT.CDFILIAL
               AND CDCAIXA =  C_REDZEXPORT.CDCAIXA
               AND NRECFREDZ = C_REDZEXPORT.NRECFREDZ
               AND DTREDUCAOZ = C_REDZEXPORT.DTREDUCAOZ
               AND CDIMPOSTO =  '00'
               AND VRALIQIMPRZ = 18;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_WD_BAS18 := 0;
         END;

         BEGIN
            SELECT VRBCALCIMPRZ
              INTO V_WD_BAS25
              FROM IMPOSTOREDZ
             WHERE CDFILIAL = C_REDZEXPORT.CDFILIAL
               AND CDCAIXA =  C_REDZEXPORT.CDCAIXA
               AND NRECFREDZ = C_REDZEXPORT.NRECFREDZ
               AND DTREDUCAOZ = C_REDZEXPORT.DTREDUCAOZ
               AND CDIMPOSTO =  '00'
               AND VRALIQIMPRZ = 25;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_WD_BAS25 := 0;
         END;

         BEGIN
            SELECT WD_IDREDZ.NEXTVAL
              INTO V_NOVOCODIGO
              FROM DUAL;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NOVOCODIGO := 1;
         END;

         DBMS_OUTPUT.PUT_LINE(V_NOVOCODIGO);

         V_DADOS := (SUBSTR(V_FILIAL, 7, 2)||                                               --01
                     SUBSTR(V_FILIAL, 9, 2)||                                               --03
                     TO_CHAR(C_REDZEXPORT.DTREDUCAOZ,'YYYYMMDD')||                          --05
                     LPAD(V_NOVOCODIGO,6,' ')||                                             --13
                     LPAD(SUBSTR(LPAD(C_REDZEXPORT.NRECFREDZ, 10, ' '),4,7),10,' ') ||      --19
                     TRIM(SUBSTR(LPAD(C_REDZEXPORT.NRSERIEREDZ, 30, ' '),11,20))||          --29
                     LPAD(TO_NUMBER(C_REDZEXPORT.NRREDREDZ),5,' ') ||                       --49
                     LPAD(TRIM(REPLACE(REPLACE(TO_CHAR(C_REDZEXPORT.VRGTREDZ-C_REDZEXPORT.VRVENBRUREDZ,
                                              '99999999990D00',
                                              'NLS_NUMERIC_CHARACTERS=,.'),
                                              ',','.'),'x','')),12,' ')||                   --54
                     LPAD(TRIM(REPLACE(REPLACE(TO_CHAR(C_REDZEXPORT.VRGTREDZ,
                                              '99999999990D00',
                                              'NLS_NUMERIC_CHARACTERS=,.'),
                                              ',','.'),'x','')),14,' ')||                   --68
                     LPAD(TO_NUMBER(C_REDZEXPORT.NRPRIMCFREDZ), 8, ' ')||                   --82
                     LPAD(TO_NUMBER(C_REDZEXPORT.NRULTCFREDZ), 6, ' ')||                    --88
                     LPAD(TRIM(REPLACE(REPLACE(TO_CHAR(C_REDZEXPORT.VRVENBRUREDZ,
                                              '99999999990D00',
                                              'NLS_NUMERIC_CHARACTERS=,.'),
                                              ',','.'),'x','')),12,' ')||                   --94
                     LPAD(TRIM(REPLACE(REPLACE(TO_CHAR(C_REDZEXPORT.VRTOTCANREDZ,
                                              '99999999990D00',
                                              'NLS_NUMERIC_CHARACTERS=,.'),
                                              ',','.'),'x','')),14,' ')||                   --108
                     LPAD(TRIM(REPLACE(REPLACE(TO_CHAR(C_REDZEXPORT.VRSTRIBREDZ,
                                              '99999999990D00',
                                              'NLS_NUMERIC_CHARACTERS=,.'),
                                              ',','.'),'x','')),14,' ')||                   --122
                     LPAD(TRIM(REPLACE(REPLACE(TO_CHAR(C_REDZEXPORT.VRTOTDESREDZ,
                                              '99999999990D00',
                                              'NLS_NUMERIC_CHARACTERS=,.'),
                                              ',','.'),'x','')),14,' ')||                   --136
                     LPAD(TRIM(REPLACE(REPLACE(TO_CHAR(C_REDZEXPORT.VRISENCREDZ,
                                              '99999999990D00',
                                              'NLS_NUMERIC_CHARACTERS=,.'),
                                              ',','.'),'x','')),14,' ')||                   --150
                     LPAD(TRIM(REPLACE(REPLACE(TO_CHAR(C_REDZEXPORT.VRNINCIDREDZ,
                                              '99999999990D00',
                                              'NLS_NUMERIC_CHARACTERS=,.'),
                                              ',','.'),'x','')),14,' ')||                   --164
                     LPAD(TO_NUMBER(C_REDZEXPORT.NRULTCFREDZ), 8, ' ')||                    --88
                     LPAD(TRIM(REPLACE(REPLACE(TO_CHAR(V_OUTROSR,
                                              '99999999990D00',
                                              'NLS_NUMERIC_CHARACTERS=,.'),
                                              ',','.'),'x','')),12,' ')||                   --184
                     NVL(LPAD(TRIM(REPLACE(REPLACE(TO_CHAR(V_IMPDEBT,
                                              '99999999990D00',
                                              'NLS_NUMERIC_CHARACTERS=,.'),
                                              ',','.'),'x','')),14,' '),'        0.0000')|| --198
                     LPAD(TO_NUMBER(C_REDZEXPORT.NRREINIREDZ),5,' ')||                      --212

                    '          3.20'||                                                      --215
                     LPAD(TRIM(REPLACE(REPLACE(TO_CHAR(V_WD_BAS32,
                                     '99999999990D00',
                                     'NLS_NUMERIC_CHARACTERS=,.'),
                                     ',','.'),'x','')),12,' ')  ||                          --229
                     '            7.00'||                                                   --243
                     LPAD(TRIM(REPLACE(REPLACE(TO_CHAR(V_WD_BAS7,
                                     '99999999990D00',
                                     'NLS_NUMERIC_CHARACTERS=,.'),
                                     ',','.'),'x','')),12,' ')||                            --257
                     '            8.40'||                                                   --271
                     LPAD(TRIM(REPLACE(REPLACE(TO_CHAR(V_WD_BAS84,
                                     '99999999990D00',
                                     'NLS_NUMERIC_CHARACTERS=,.'),
                                     ',','.'),'x','')),12,' ')||                            --285
                     '           12.00'||                                                   --299
                     LPAD(TRIM(REPLACE(REPLACE(TO_CHAR(V_WD_BAS12,
                                     '99999999990D00',
                                     'NLS_NUMERIC_CHARACTERS=,.'),
                                     ',','.'),'x','')),12,' ')||                            --313
                     '           18.00'||                                                   --327
                     LPAD(TRIM(REPLACE(REPLACE(TO_CHAR(V_WD_BAS18,
                                     '99999999990D00',
                                     'NLS_NUMERIC_CHARACTERS=,.'),
                                     ',','.'),'x','')),12,' ')||                            --341
                     '           25.00'||                                                   --355
                     LPAD(TRIM(REPLACE(REPLACE(TO_CHAR(V_WD_BAS25,
                                     '99999999990D00',
                                     'NLS_NUMERIC_CHARACTERS=,.'),
                                     ',','.'),'x','')),12,' ')||                            --369
                    '            0.00        0.00            0.00        0.00            0.00        0.00  '||
                    '          0.00        0.00            0.00        0.00            0.00        0.00  '||
                    '          0.00        0.00            0.00        0.00            0.00        0.00  '||
                    '          0.00        0.00            0.00        0.00  '
                    );

         INSERT INTO VND_TMP (TIPO, ID, TEXTO) VALUES ('1',V_LINHA,V_DADOS);

         V_LINHA := V_LINHA +1;


         --Cupons (NF de sada) - Tipo 2 - Filial_AAAAMMDD_NFS.TXT
         FOR C_CUPONSEXPORT IN (SELECT V.NRCUPOMFIS, V.DTENTRVENDA, P.CDARVPROD, I.NRSEQUITVEND NRSEQUITVEND, I.QTPRODVEND QTPRODVEND,
                                       I.VRUNITVEND VRUNITVEND, I.VRALIQIMPR VRALIQIMPR,DECODE(V.IDSITUVENDA,'C','D','O','N') IDSITUVENDA,
                                       V.NRSEQVENDA
                                  FROM VENDA V, ITEMVENDA I, PRODUTO P
                                 WHERE V.CDFILIAL = I.CDFILIAL
                                   AND V.CDCAIXA = I.CDCAIXA
                                   AND V.NRSEQVENDA = I.NRSEQVENDA
                                   AND I.CDPRODUTO = P.CDPRODUTO
                                   AND TRUNC(V.DTENTRVENDA) = C_REDZEXPORT.DTREDUCAOZ
                                   AND V.CDFILIAL = C_REDZEXPORT.CDFILIAL
                                   AND V.CDCAIXA = C_REDZEXPORT.CDCAIXA
                                   AND V.IDSITUVENDA = 'O' -- Cupons no cancelados

                                 UNION ALL

                                  --tens cancelados
                                SELECT V.NRCUPOMFIS, V.DTENTRVENDA, P.CDARVPROD, I.NRSEQITVENDC NRSEQUITVEND, I.QTPRODVENDC QTPRODVEND,
                                       I.VRUNITVENDC VRUNITVEND, I.VRALIQIMPRIC VRALIQIMPR,'D' IDSITUVENDA,
                                       V.NRSEQVENDA
                                  FROM VENDA V, ITVENDACAN I, PRODUTO P
                                 WHERE V.CDFILIAL = I.CDFILIAL
                                   AND V.CDCAIXA = I.CDCAIXA
                                   AND V.NRSEQVENDA = I.NRSEQVENDA
                                   AND I.CDPRODUTO = P.CDPRODUTO
                                   AND TRUNC(V.DTENTRVENDA) = C_REDZEXPORT.DTREDUCAOZ
                                   AND V.CDFILIAL = C_REDZEXPORT.CDFILIAL
                                   AND V.CDCAIXA = C_REDZEXPORT.CDCAIXA
                                 ORDER BY DTENTRVENDA, NRSEQVENDA, IDSITUVENDA DESC, NRSEQUITVEND)
         LOOP
            V_DADOS := (SUBSTR(V_FILIAL, 7, 2)||                                                               --01
                        SUBSTR(V_FILIAL, 9, 2)||                                                               --03
                        LPAD(TO_NUMBER(C_CUPONSEXPORT.NRCUPOMFIS),6,' ')||                                     --05
                        LPAD(TO_NUMBER(C_REDZEXPORT.NRECFREDZ),3,'0')||                                        --11
                        TRIM(SUBSTR(LPAD(C_REDZEXPORT.NRSERIEREDZ, 30, ' '),11,20))||                          --14
                        TO_CHAR(C_REDZEXPORT.DTREDUCAOZ,'YYYYMMDD')||                                          --34
                        LPAD(TO_NUMBER(C_CUPONSEXPORT.NRSEQUITVEND),4,' ') ||
                        LPAD(TRIM(C_CUPONSEXPORT.CDARVPROD),15,' ')||                                          --46
                        LPAD(TRIM(C_CUPONSEXPORT.QTPRODVEND),14,' ')||                                         --61
                        LPAD(TRIM(REPLACE(REPLACE(TO_CHAR(C_CUPONSEXPORT.VRUNITVEND,
                           '9999999999990D00',
                           'NLS_NUMERIC_CHARACTERS=,.'),
                           ',','.'),'x','')),14,' ')||                                                         --75
                        LPAD(TRIM(REPLACE(REPLACE(TO_CHAR(C_CUPONSEXPORT.QTPRODVEND*C_CUPONSEXPORT.VRUNITVEND,
                           '9999999999990D00',
                           'NLS_NUMERIC_CHARACTERS=,.'),
                           ',','.'),'x','')),14,' ')||                                                         --89
                        LPAD(TRIM(REPLACE(REPLACE(TO_CHAR(C_CUPONSEXPORT.QTPRODVEND*C_CUPONSEXPORT.VRUNITVEND,
                           '9999999999990D00',
                           'NLS_NUMERIC_CHARACTERS=,.'),
                           ',','.'),'x','')),14,' ')||                                                         --103
                        LPAD(TRIM(REPLACE(REPLACE(TO_CHAR(C_CUPONSEXPORT.VRALIQIMPR,
                           '9999999999990D00',
                           'NLS_NUMERIC_CHARACTERS=,.'),
                           ',','.'),'x','')),6,' ')||                                                          --117
                        LPAD(TRIM(REPLACE(REPLACE(TO_CHAR(TRUNC(((C_CUPONSEXPORT.QTPRODVEND*C_CUPONSEXPORT.VRUNITVEND)*C_CUPONSEXPORT.VRALIQIMPR)/100,2),
                           '9999999999990D00',
                           'NLS_NUMERIC_CHARACTERS=,.'),
                           ',','.'),'x','')),14,' ')||                                                         --123
                        C_CUPONSEXPORT.IDSITUVENDA                                                             --137

                      );

            INSERT INTO VND_TMP (TIPO, ID, TEXTO) VALUES ('2',V_LINHA,V_DADOS);

            V_LINHA := V_LINHA +1;
         END LOOP;

         --Recebimentos - Tipo 3 - Filial_AAAAMMDD_FP.TXT
         FOR C_RECEBEXPORT IN (SELECT T.CDTIPORECE , T.NMTIPORECE, M.VRMOVIVEND  , M.CDFILIAL    ,
                                      M.CDCAIXA    , M.DTABERCAIX, M.NRSEQUMOVI  , M.IDTIPOMOVIVE,
                                      M.DTHRINCMOV , M.NRSEQVENDA, M.DTMOVIMCAIXA, M.VRMOVIVEOUT ,
                                      M.VRCOTINDOUT, T.IDTIPORECE, T.CDINDICE,V.NRCUPOMFIS,
                                      (SELECT VRMOVIVEND
                                         FROM MOVCAIXA A
                                        WHERE A.IDTIPOMOVIVE = 'S'
                                          AND A.CDFILIAL = M.CDFILIAL
                                          AND A.CDCAIXA = M.CDCAIXA
                                          AND A.NRSEQVENDA = M.NRSEQVENDA
                                          AND A.CDTIPORECE = M.CDTIPORECE) TROCO,
                                      DECODE(M.IDTIPOMOVIVE, 'C', 'D', 'N') AS IDTIPO
                                 FROM TIPORECE T, MOVCAIXA M, VENDA V
                                WHERE M.IDTIPOMOVIVE IN ('E', 'T', 'C')
                                  AND T.CDTIPORECE = M.CDTIPORECE
                                  AND M.CDFILIAL = V.CDFILIAL
                                  AND M.CDCAIXA = V.CDCAIXA
                                  AND M.NRSEQVENDA = V.NRSEQVENDA
                                  AND M.CDFILIAL = C_REDZEXPORT.CDFILIAL
                                  AND M.CDCAIXA = C_REDZEXPORT.CDCAIXA
                                  AND TRUNC(M.DTMOVIMCAIXA) = C_REDZEXPORT.DTREDUCAOZ)
         LOOP
            V_DADOS := (SUBSTR(V_FILIAL, 7, 2)||                                                                  --01
                        SUBSTR(V_FILIAL, 9, 2)||                                                                  --03
                        LPAD(TO_NUMBER(C_RECEBEXPORT.NRCUPOMFIS),6,' ')||                                         --05
                        LPAD(TO_NUMBER(C_REDZEXPORT.NRECFREDZ),3,'0')||
                        TRIM(SUBSTR(LPAD(C_REDZEXPORT.NRSERIEREDZ, 30, ' '),11,20))||                             --14
                        TO_CHAR(C_REDZEXPORT.DTREDUCAOZ,'YYYYMMDD')||                                             --34
                        RPAD(C_RECEBEXPORT.NMTIPORECE,20,' ')||                                                   --42
                        NVL(LPAD(TRIM(REPLACE(TO_CHAR(C_RECEBEXPORT.VRMOVIVEND,
                                                '99999999990D00',
                                                'NLS_NUMERIC_CHARACTERS=,.'),
                                                ',','.')),14,' '),'          0.00')||                             --62
                        NVL(LPAD(TRIM(REPLACE(TO_CHAR(C_RECEBEXPORT.TROCO,
                                                '99999999990D00',
                                                'NLS_NUMERIC_CHARACTERS=,.'),
                                                ',','.')),14,' '),'          0.00') ||                             --76
                        C_RECEBEXPORT.IDTIPO
                       );

            INSERT INTO VND_TMP (TIPO, ID, TEXTO) VALUES ('3',V_LINHA,V_DADOS);

            V_LINHA := V_LINHA +1;
         END LOOP;

         --Recebimentos - Tipo 4 - Filial_AAAAMMDD_CR.TXT
         FOR C_RECEBEXPREC IN (SELECT T.CDTIPORECE , T.NMTIPORECE, M.VRMOVIVEND  , M.CDFILIAL    ,
                                      M.CDCAIXA    , M.DTABERCAIX, M.NRSEQUMOVI  , M.IDTIPOMOVIVE,
                                      M.DTHRINCMOV , M.NRSEQVENDA, M.DTMOVIMCAIXA, M.VRMOVIVEOUT ,
                                      M.VRCOTINDOUT, T.IDTIPORECE, T.CDINDICE,V.NRCUPOMFIS,
                                      (SELECT VRMOVIVEND
                                         FROM MOVCAIXA A
                                        WHERE A.IDTIPOMOVIVE = 'S'
                                          AND A.CDFILIAL = M.CDFILIAL
                                          AND A.CDCAIXA = M.CDCAIXA
                                          AND A.NRSEQVENDA = M.NRSEQVENDA
                                          AND A.CDTIPORECE = M.CDTIPORECE) TROCO,
                                      DECODE(M.IDTIPOMOVIVE, 'C', 'D', 'N') AS IDTIPO
                                 FROM TIPORECE T, MOVCAIXA M, VENDA V
                                WHERE M.IDTIPOMOVIVE IN ('E', 'T', 'C')
                                  AND T.CDTIPORECE = M.CDTIPORECE
                                  AND M.CDFILIAL = V.CDFILIAL
                                  AND M.CDCAIXA = V.CDCAIXA
                                  AND M.NRSEQVENDA = V.NRSEQVENDA
                                  AND M.CDFILIAL = C_REDZEXPORT.CDFILIAL
                                  AND M.CDCAIXA = C_REDZEXPORT.CDCAIXA
                                  AND TRUNC(M.DTMOVIMCAIXA) = C_REDZEXPORT.DTREDUCAOZ)
         LOOP
            V_DADOS := (SUBSTR(V_FILIAL, 7, 2)||                                                                  --01
                        SUBSTR(V_FILIAL, 9, 2)||                                                                  --03
                        TO_CHAR(C_REDZEXPORT.DTREDUCAOZ,'YYYYMMDD')||                                             --05
                        LPAD(TO_NUMBER(C_RECEBEXPREC.CDTIPORECE),17,' ')||                                        --13
                        NVL(LPAD(TRIM(REPLACE(TO_CHAR(C_RECEBEXPREC.VRMOVIVEND,
                                                '99999999990D00',
                                                'NLS_NUMERIC_CHARACTERS=,.'),
                                                ',','.')),15,' '),'           0.00')||                            --30
                        '           0.00' ||                                                                      --45
                        '           0.00' ||                                                                      --60
                        RPAD(C_RECEBEXPREC.NMTIPORECE,30,' ')                                                     --75
                       );

            INSERT INTO VND_TMP (TIPO, ID, TEXTO) VALUES ('4',V_LINHA,V_DADOS);

            V_LINHA := V_LINHA +1;
         END LOOP;

         UPDATE REDUCAOZ
            SET USR_IDEXPORTA = 'N',
                USR_DTEXPORTA = SYSDATE
          WHERE CDFILIAL = C_REDZEXPORT.CDFILIAL
            AND DTREDUCAOZ = C_REDZEXPORT.DTREDUCAOZ
            AND CDCAIXA = C_REDZEXPORT.CDCAIXA
            AND NRECFREDZ = C_REDZEXPORT.NRECFREDZ;

      END IF;

      V_COUNT := V_COUNT + 1;

      IF V_COUNT = 250 THEN
         V_COUNT := 0;
         COMMIT;
      END IF;

   END LOOP;

   IF V_COUNT > 0 THEN
      GERA_ARQUIVO_VENDAS('OL',
                          SUBSTR(V_FILIAL, 7, 2)||SUBSTR(V_FILIAL, 9, 2)||'_'||V_DATAARQ||'_RZ'||'.TXT',
                          SUBSTR(V_FILIAL, 7, 2)||SUBSTR(V_FILIAL, 9, 2)||'_'||V_DATAARQ||'_NFS'||'.TXT',
                          SUBSTR(V_FILIAL, 7, 2)||SUBSTR(V_FILIAL, 9, 2)||'_'||V_DATAARQ||'_FP'||'.TXT',
                          SUBSTR(V_FILIAL, 7, 2)||SUBSTR(V_FILIAL, 9, 2)||'_'||V_DATAARQ||'_CR'||'.TXT');
   END IF;                          

   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EXPORTA_VENDAS_DN','5.75.XXX'); END;
/
